Package com.tibco.patterns.qbp

## Class DateQueryDef

- java.lang.Object
- - com.tibco.patterns.qbp.QueryDef
  - - com.tibco.patterns.qbp.DateQueryDef

-     public class DateQueryDef
      extends QueryDef

  Definition of a Date query. Holds all parameters to create a Date NetricsQuery object.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DateQueryDef​(java.lang.String dataSourceSpec, java.lang.String fieldName)` | Creates a Date query definition.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `DateQueryDef` | `emptyScore​(java.lang.Double emptyScore)` |
    `java.lang.String` | `getDataSourceSpec()` |
    `java.util.Optional<java.lang.Double>` | `getEmptyScore()` |
    `java.lang.String` | `getFieldName()` |
    `java.util.Optional<java.lang.Double>` | `getInvalidScore()` |
    `DateQueryDef` | `invalidScore​(java.lang.Double invalidScore)` |
    `java.util.Optional<java.lang.Boolean>` | `isMatchEmpty()` |
    `DateQueryDef` | `matchEmpty​(java.lang.Boolean matchEmpty)` |

    - ### Methods inherited from class com.tibco.patterns.qbp.QueryDef

      `getGroupName, getQueryName, groupName, queryName`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DateQueryDef

          public DateQueryDef​(java.lang.String dataSourceSpec,
                              java.lang.String fieldName)

      Creates a Date query definition.
      Parameters:
        `dataSourceSpec` - - defines the content of the query string. Not null. Input fields can be specified using the ${dflt-input-field-name} convention.
        `fieldName` - - the field the Date query uses to query. The field name must be a default output field name. Not null.
      Throws:
        `java.lang.IllegalArgumentException` - if fieldName or dataSourceSpec is null or empty.

  - ### Method Detail

    - #### getDataSourceSpec

          public java.lang.String getDataSourceSpec()

      Returns:
        the definition of the content of the query string.

    - #### getFieldName

          public java.lang.String getFieldName()

      Returns:
        the the field the Date query uses to query.

    - #### matchEmpty

          public DateQueryDef matchEmpty​(java.lang.Boolean matchEmpty)

      Parameters:
        `matchEmpty` - the Match Empty Values property to set, or null to use the default (false).

    - #### isMatchEmpty

          public java.util.Optional<java.lang.Boolean> isMatchEmpty()

      Returns:
        the Match Empty Values property, or empty if the default (false) is used.

    - #### emptyScore

          public DateQueryDef emptyScore​(java.lang.Double emptyScore)

      Parameters:
        `emptyScore` - the score to assign if the record or query data is empty, or null to use the default empty score.
      Throws:
        `java.lang.IllegalArgumentException` - the value is given and not between 0.0 and 1.0 or -1.0.

    - #### getEmptyScore

          public java.util.Optional<java.lang.Double> getEmptyScore()

      Returns:
        the empty score, or empty Optional if the default is used.

    - #### invalidScore

          public DateQueryDef invalidScore​(java.lang.Double invalidScore)

      Parameters:
        `invalidScore` - the score to assign if the record or query data contains invalid data.
      Throws:
        `java.lang.IllegalArgumentException` - the value is given and not between 0.0 and 1.0 or -1.0.

    - #### getInvalidScore

          public java.util.Optional<java.lang.Double> getInvalidScore()

      Returns:
        the invalid score, or empty Optional if the default is used.